diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_french.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_french.c
index fc79c0a24d..1a1732b216 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_french.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_french.c
@@ -889,55 +868,50 @@ static int r_standard_suffix(struct SN_env * z) {
                 }
                 goto lab14;
             lab15:
-                z->c = z->l - m6;
-                {   int ret = r_R1(z);
-                    if (ret == 0) return 0; /* call R1, line 147 */
-                    if (ret < 0) return ret;
+                z->c = z->l - m10;
+                {   int ret = r_R1(z); /* call R1, line 147 */
+                    if (ret <= 0) return ret;
                 }
-                {   int ret = slice_from_s(z, 3, s_29); /* <-, line 147 */
+                {   int ret = slice_from_s(z, 3, s_23); /* <-, line 147 */
                     if (ret < 0) return ret;
                 }
             }
         lab14:
             break;
         case 12:
-            {   int ret = r_R1(z);
-                if (ret == 0) return 0; /* call R1, line 150 */
-                if (ret < 0) return ret;
+            {   int ret = r_R1(z); /* call R1, line 150 */
+                if (ret <= 0) return ret;
             }
-            if (out_grouping_b(z, g_v, 97, 251, 0)) return 0;
+            if (out_grouping_b(z, g_v, 97, 251, 0)) return 0; /* non v, line 150 */
             {   int ret = slice_del(z); /* delete, line 150 */
                 if (ret < 0) return ret;
             }
             break;
         case 13:
-            {   int ret = r_RV(z);
-                if (ret == 0) return 0; /* call RV, line 155 */
-                if (ret < 0) return ret;
+            {   int ret = r_RV(z); /* call RV, line 155 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 3, s_30); /* <-, line 155 */
+            {   int ret = slice_from_s(z, 3, s_24); /* <-, line 155 */
                 if (ret < 0) return ret;
             }
             return 0; /* fail, line 155 */
             break;
         case 14:
-            {   int ret = r_RV(z);
-                if (ret == 0) return 0; /* call RV, line 156 */
-                if (ret < 0) return ret;
+            {   int ret = r_RV(z); /* call RV, line 156 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 3, s_31); /* <-, line 156 */
+            {   int ret = slice_from_s(z, 3, s_25); /* <-, line 156 */
                 if (ret < 0) return ret;
             }
             return 0; /* fail, line 156 */
             break;
         case 15:
-            {   int m_test = z->l - z->c; /* test, line 158 */
-                if (in_grouping_b(z, g_v, 97, 251, 0)) return 0;
-                {   int ret = r_RV(z);
-                    if (ret == 0) return 0; /* call RV, line 158 */
-                    if (ret < 0) return ret;
+            {   int m_test11 = z->l - z->c; /* test, line 158 */
+                if (in_grouping_b(z, g_v, 97, 251, 0)) return 0; /* grouping v, line 158 */
+                {   int ret = r_RV(z); /* call RV, line 158 */
+                    if (ret <= 0) return ret;
                 }
-                z->c = z->l - m_test;
+                z->c = z->l - m_test11;
             }
             {   int ret = slice_del(z); /* delete, line 158 */
                 if (ret < 0) return ret;
@@ -948,50 +922,38 @@ static int r_standard_suffix(struct SN_env * z) {
     return 1;
 }
 
-static int r_i_verb_suffix(struct SN_env * z) {
-    int among_var;
-    {   int mlimit; /* setlimit, line 163 */
-        int m1 = z->l - z->c; (void)m1;
+static int r_i_verb_suffix(struct SN_env * z) { /* backwardmode */
+
+    {   int mlimit1; /* setlimit, line 163 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 163 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit1 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 164 */
-        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((68944418 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit; return 0; }
-        among_var = find_among_b(z, a_5, 35); /* substring, line 164 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((68944418 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit1; return 0; } /* substring, line 164 */
+        if (!(find_among_b(z, a_5, 35))) { z->lb = mlimit1; return 0; }
         z->bra = z->c; /* ], line 164 */
-        switch(among_var) {
-            case 0: { z->lb = mlimit; return 0; }
-            case 1:
-                if (out_grouping_b(z, g_v, 97, 251, 0)) { z->lb = mlimit; return 0; }
-                {   int ret = slice_del(z); /* delete, line 170 */
-                    if (ret < 0) return ret;
-                }
-                break;
+        if (out_grouping_b(z, g_v, 97, 251, 0)) { z->lb = mlimit1; return 0; } /* non v, line 170 */
+        {   int ret = slice_del(z); /* delete, line 170 */
+            if (ret < 0) return ret;
         }
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
     return 1;
 }
 
-static int r_verb_suffix(struct SN_env * z) {
+static int r_verb_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 174 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 174 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 174 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit1 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 175 */
         among_var = find_among_b(z, a_6, 38); /* substring, line 175 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
         z->bra = z->c; /* ], line 175 */
-        switch(among_var) {
-            case 0: { z->lb = mlimit; return 0; }
+        switch (among_var) { /* among, line 175 */
             case 1:
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->lb = mlimit; return 0; } /* call R2, line 177 */
+                {   int ret = r_R2(z); /* call R2, line 177 */
+                    if (ret == 0) { z->lb = mlimit1; return 0; }
                     if (ret < 0) return ret;
                 }
                 {   int ret = slice_del(z); /* delete, line 177 */
@@ -1007,9 +969,10 @@ static int r_verb_suffix(struct SN_env * z) {
                 {   int ret = slice_del(z); /* delete, line 190 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 191 */
+                {   int m2 = z->l - z->c; (void)m2; /* try, line 191 */
                     z->ket = z->c; /* [, line 191 */
-                    if (!(eq_s_b(z, 1, s_32))) { z->c = z->l - m_keep; goto lab0; }
+                    if (z->c <= z->lb || z->p[z->c - 1] != 'e') { z->c = z->l - m2; goto lab0; } /* literal, line 191 */
+                    z->c--;
                     z->bra = z->c; /* ], line 191 */
                     {   int ret = slice_del(z); /* delete, line 191 */
                         if (ret < 0) return ret;
@@ -1019,20 +982,21 @@ static int r_verb_suffix(struct SN_env * z) {
                 }
                 break;
         }
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
     return 1;
 }
 
-static int r_residual_suffix(struct SN_env * z) {
+static int r_residual_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 199 */
+    {   int m1 = z->l - z->c; (void)m1; /* try, line 199 */
         z->ket = z->c; /* [, line 199 */
-        if (!(eq_s_b(z, 1, s_33))) { z->c = z->l - m_keep; goto lab0; }
+        if (z->c <= z->lb || z->p[z->c - 1] != 's') { z->c = z->l - m1; goto lab0; } /* literal, line 199 */
+        z->c--;
         z->bra = z->c; /* ], line 199 */
-        {   int m_test = z->l - z->c; /* test, line 199 */
-            if (out_grouping_b(z, g_keep_with_s, 97, 232, 0)) { z->c = z->l - m_keep; goto lab0; }
-            z->c = z->l - m_test;
+        {   int m_test2 = z->l - z->c; /* test, line 199 */
+            if (out_grouping_b(z, g_keep_with_s, 97, 232, 0)) { z->c = z->l - m1; goto lab0; } /* non keep_with_s, line 199 */
+            z->c = z->l - m_test2;
         }
         {   int ret = slice_del(z); /* delete, line 199 */
             if (ret < 0) return ret;
@@ -1040,29 +1004,28 @@ static int r_residual_suffix(struct SN_env * z) {
     lab0:
         ;
     }
-    {   int mlimit; /* setlimit, line 200 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit3; /* setlimit, line 200 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 200 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit3 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 201 */
         among_var = find_among_b(z, a_7, 7); /* substring, line 201 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (!(among_var)) { z->lb = mlimit3; return 0; }
         z->bra = z->c; /* ], line 201 */
-        switch(among_var) {
-            case 0: { z->lb = mlimit; return 0; }
+        switch (among_var) { /* among, line 201 */
             case 1:
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->lb = mlimit; return 0; } /* call R2, line 202 */
+                {   int ret = r_R2(z); /* call R2, line 202 */
+                    if (ret == 0) { z->lb = mlimit3; return 0; }
                     if (ret < 0) return ret;
                 }
-                {   int m2 = z->l - z->c; (void)m2; /* or, line 202 */
-                    if (!(eq_s_b(z, 1, s_34))) goto lab2;
+                {   int m4 = z->l - z->c; (void)m4; /* or, line 202 */
+                    if (z->c <= z->lb || z->p[z->c - 1] != 's') goto lab2; /* literal, line 202 */
+                    z->c--;
                     goto lab1;
                 lab2:
-                    z->c = z->l - m2;
-                    if (!(eq_s_b(z, 1, s_35))) { z->lb = mlimit; return 0; }
+                    z->c = z->l - m4;
+                    if (z->c <= z->lb || z->p[z->c - 1] != 't') { z->lb = mlimit3; return 0; } /* literal, line 202 */
+                    z->c--;
                 }
             lab1:
                 {   int ret = slice_del(z); /* delete, line 202 */
@@ -1070,7 +1033,7 @@ static int r_residual_suffix(struct SN_env * z) {
                 }
                 break;
             case 2:
-                {   int ret = slice_from_s(z, 1, s_36); /* <-, line 204 */
+                {   int ret = slice_from_s(z, 1, s_26); /* <-, line 204 */
                     if (ret < 0) return ret;
                 }
                 break;
@@ -1080,22 +1043,22 @@ static int r_residual_suffix(struct SN_env * z) {
                 }
                 break;
             case 4:
-                if (!(eq_s_b(z, 2, s_37))) { z->lb = mlimit; return 0; }
+                if (!(eq_s_b(z, 2, s_27))) { z->lb = mlimit3; return 0; } /* literal, line 206 */
                 {   int ret = slice_del(z); /* delete, line 206 */
                     if (ret < 0) return ret;
                 }
                 break;
         }
-        z->lb = mlimit;
+        z->lb = mlimit3;
     }
     return 1;
 }
 
-static int r_un_double(struct SN_env * z) {
-    {   int m_test = z->l - z->c; /* test, line 212 */
-        if (z->c - 2 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1069056 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-        if (!(find_among_b(z, a_8, 5))) return 0; /* among, line 212 */
-        z->c = z->l - m_test;
+static int r_un_double(struct SN_env * z) { /* backwardmode */
+    {   int m_test1 = z->l - z->c; /* test, line 212 */
+        if (z->c - 2 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1069056 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* among, line 212 */
+        if (!(find_among_b(z, a_8, 5))) return 0;
+        z->c = z->l - m_test1;
     }
     z->ket = z->c; /* [, line 212 */
     if (z->c <= z->lb) return 0;
@@ -1107,10 +1070,10 @@ static int r_un_double(struct SN_env * z) {
     return 1;
 }
 
-static int r_un_accent(struct SN_env * z) {
+static int r_un_accent(struct SN_env * z) { /* backwardmode */
     {   int i = 1;
         while(1) { /* atleast, line 216 */
-            if (out_grouping_b(z, g_v, 97, 251, 0)) goto lab0;
+            if (out_grouping_b(z, g_v, 97, 251, 0)) goto lab0; /* non v, line 216 */
             i--;
             continue;
         lab0:
@@ -1120,78 +1083,80 @@ static int r_un_accent(struct SN_env * z) {
     }
     z->ket = z->c; /* [, line 217 */
     {   int m1 = z->l - z->c; (void)m1; /* or, line 217 */
-        if (!(eq_s_b(z, 1, s_38))) goto lab2;
+        if (z->c <= z->lb || z->p[z->c - 1] != 0xE9) goto lab2; /* literal, line 217 */
+        z->c--;
         goto lab1;
     lab2:
         z->c = z->l - m1;
-        if (!(eq_s_b(z, 1, s_39))) return 0;
+        if (z->c <= z->lb || z->p[z->c - 1] != 0xE8) return 0; /* literal, line 217 */
+        z->c--;
     }
 lab1:
     z->bra = z->c; /* ], line 217 */
-    {   int ret = slice_from_s(z, 1, s_40); /* <-, line 217 */
+    {   int ret = slice_from_s(z, 1, s_28); /* <-, line 217 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-extern int french_ISO_8859_1_stem(struct SN_env * z) {
+extern int french_ISO_8859_1_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* do, line 223 */
-        {   int ret = r_prelude(z);
-            if (ret == 0) goto lab0; /* call prelude, line 223 */
+        {   int ret = r_prelude(z); /* call prelude, line 223 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = c1;
     }
-    {   int c2 = z->c; /* do, line 224 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab1; /* call mark_regions, line 224 */
-            if (ret < 0) return ret;
-        }
-    lab1:
-        z->c = c2;
+    /* do, line 224 */
+    {   int ret = r_mark_regions(z); /* call mark_regions, line 224 */
+        if (ret == 0) goto lab1;
+        if (ret < 0) return ret;
     }
+lab1:
     z->lb = z->c; z->c = z->l; /* backwards, line 225 */
 
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 227 */
-        {   int m4 = z->l - z->c; (void)m4; /* or, line 237 */
-            {   int m5 = z->l - z->c; (void)m5; /* and, line 233 */
-                {   int m6 = z->l - z->c; (void)m6; /* or, line 229 */
-                    {   int ret = r_standard_suffix(z);
-                        if (ret == 0) goto lab6; /* call standard_suffix, line 229 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 227 */
+        {   int m3 = z->l - z->c; (void)m3; /* or, line 237 */
+            {   int m4 = z->l - z->c; (void)m4; /* and, line 233 */
+                {   int m5 = z->l - z->c; (void)m5; /* or, line 229 */
+                    {   int ret = r_standard_suffix(z); /* call standard_suffix, line 229 */
+                        if (ret == 0) goto lab6;
                         if (ret < 0) return ret;
                     }
                     goto lab5;
                 lab6:
-                    z->c = z->l - m6;
-                    {   int ret = r_i_verb_suffix(z);
-                        if (ret == 0) goto lab7; /* call i_verb_suffix, line 230 */
+                    z->c = z->l - m5;
+                    {   int ret = r_i_verb_suffix(z); /* call i_verb_suffix, line 230 */
+                        if (ret == 0) goto lab7;
                         if (ret < 0) return ret;
                     }
                     goto lab5;
                 lab7:
-                    z->c = z->l - m6;
-                    {   int ret = r_verb_suffix(z);
-                        if (ret == 0) goto lab4; /* call verb_suffix, line 231 */
+                    z->c = z->l - m5;
+                    {   int ret = r_verb_suffix(z); /* call verb_suffix, line 231 */
+                        if (ret == 0) goto lab4;
                         if (ret < 0) return ret;
                     }
                 }
             lab5:
-                z->c = z->l - m5;
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 234 */
+                z->c = z->l - m4;
+                {   int m6 = z->l - z->c; (void)m6; /* try, line 234 */
                     z->ket = z->c; /* [, line 234 */
                     {   int m7 = z->l - z->c; (void)m7; /* or, line 234 */
-                        if (!(eq_s_b(z, 1, s_41))) goto lab10;
+                        if (z->c <= z->lb || z->p[z->c - 1] != 'Y') goto lab10; /* literal, line 234 */
+                        z->c--;
                         z->bra = z->c; /* ], line 234 */
-                        {   int ret = slice_from_s(z, 1, s_42); /* <-, line 234 */
+                        {   int ret = slice_from_s(z, 1, s_29); /* <-, line 234 */
                             if (ret < 0) return ret;
                         }
                         goto lab9;
                     lab10:
                         z->c = z->l - m7;
-                        if (!(eq_s_b(z, 1, s_43))) { z->c = z->l - m_keep; goto lab8; }
+                        if (z->c <= z->lb || z->p[z->c - 1] != 0xE7) { z->c = z->l - m6; goto lab8; } /* literal, line 235 */
+                        z->c--;
                         z->bra = z->c; /* ], line 235 */
-                        {   int ret = slice_from_s(z, 1, s_44); /* <-, line 235 */
+                        {   int ret = slice_from_s(z, 1, s_30); /* <-, line 235 */
                             if (ret < 0) return ret;
                         }
                     }
@@ -1202,27 +1167,27 @@ extern int french_ISO_8859_1_stem(struct SN_env * z) {
             }
             goto lab3;
         lab4:
-            z->c = z->l - m4;
-            {   int ret = r_residual_suffix(z);
-                if (ret == 0) goto lab2; /* call residual_suffix, line 238 */
+            z->c = z->l - m3;
+            {   int ret = r_residual_suffix(z); /* call residual_suffix, line 238 */
+                if (ret == 0) goto lab2;
                 if (ret < 0) return ret;
             }
         }
     lab3:
     lab2:
-        z->c = z->l - m3;
+        z->c = z->l - m2;
     }
     {   int m8 = z->l - z->c; (void)m8; /* do, line 243 */
-        {   int ret = r_un_double(z);
-            if (ret == 0) goto lab11; /* call un_double, line 243 */
+        {   int ret = r_un_double(z); /* call un_double, line 243 */
+            if (ret == 0) goto lab11;
             if (ret < 0) return ret;
         }
     lab11:
         z->c = z->l - m8;
     }
     {   int m9 = z->l - z->c; (void)m9; /* do, line 244 */
-        {   int ret = r_un_accent(z);
-            if (ret == 0) goto lab12; /* call un_accent, line 244 */
+        {   int ret = r_un_accent(z); /* call un_accent, line 244 */
+            if (ret == 0) goto lab12;
             if (ret < 0) return ret;
         }
     lab12:
@@ -1230,8 +1195,8 @@ extern int french_ISO_8859_1_stem(struct SN_env * z) {
     }
     z->c = z->lb;
     {   int c10 = z->c; /* do, line 246 */
-        {   int ret = r_postlude(z);
-            if (ret == 0) goto lab13; /* call postlude, line 246 */
+        {   int ret = r_postlude(z); /* call postlude, line 246 */
+            if (ret == 0) goto lab13;
             if (ret < 0) return ret;
         }
     lab13:
